function A=recover_qs_block(p,q,a,g,h,b,d)

% Computes matrix A from block quasiseparable generators:
% - lower generators p,q,a
% - upper generators g,h,b
% - diagonal entries d.
%
% Warning: no check for size consistency.
%

[bsize,~,N]=size(d);
[~,rL,~]=size(p);
[rU,~,~]=size(h);

% Initialize A and fill in main diagonal. 
A=zeros(bsize*N);
for j=1:N
   A((j-1)*bsize+1:j*bsize,(j-1)*bsize+1:j*bsize)=d(:,:,j);
end
% Fill in lower triangular part.

for j=2:N
    x=p(:,:,j);
    for k=j-1:-1:2
        A((j-1)*bsize+1:j*bsize,(k-1)*bsize+1:k*bsize)=x*q(:,:,k);
        x=x*a(:,:,k);
    end
    A((j-1)*bsize+1:j*bsize,1:bsize)=x*q(:,:,1);
end

% Fill in upper triangular part.

for j=1:N-1
    x=g(:,:,j);
    for k=j+1:N-1
        A((j-1)*bsize+1:j*bsize,(k-1)*bsize+1:k*bsize)=x*h(:,:,k);
        x=x*b(:,:,k);
    end
    A((j-1)*bsize+1:j*bsize,(N-1)*bsize+1:N*bsize)=x*h(:,:,N);
end

end